#############################################################################
# ___  __.                                             __                   #
#|   |/ _|______   ____  ____   ____      ____   _____/  |_  _______ __ __  #
#|     < \_  __ \_/ __ \/  _ \ /    \    /    \_/ __ \   __\ \_  __ \  |  \ #
#|   |  \ |  | \/\  ___(  <_> )   |  \  |   |  \  ___/|  |    |  | \/  |  / #
#|___|__ \|__|    \___  >____/|___|  / /\___|  /\___  >__|   /\__|  |____/  #
#       \/            \/           \/  \/    \/     \/       \/             #
#                              D i g i t a l   S i d e   o f   L i f e      #
#############################################################################
#
# statslev.tcl
#
# :
#             .
#	   .chanset #chan +nopubstatslev
#	   .
#
# : Kreon <starcom2k@gmail.com>
#
# : http://kreon.net.ru || irc.eggdrop.org.ru @ #eggdrop
# 
##############################################################################
##
namespace eval statslev {}
##
foreach bind [binds "::statslev::*"] { catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]} }
foreach p [array names statslev *] { catch {unset statslev($p) } }

setudef flag nopubstatslev


if { ![info exists egglib(ver)] } {
putlog "***********************************************"
putlog "             egglib_pub NOT FOUND !"
putlog "   Download last version of egglib_pub here:"
putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
putlog "***********************************************" 
return
}
if { [expr {$egglib(ver) < 1.4}] } {
putlog "***********************************************"
putlog " YOUR VERSION OF egglib_pub IS TOO OLD !"
putlog "   Download last version of egglib_pub here:"
putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
putlog "***********************************************"
putlog " version installed : $egglib(ver)"
putlog " version required: 1.4"
return
}
#######################
#   
set statslev(author) "Kreon <starcom2k@gmail.com>"

#  
set statslev(ver) "2.0"

#  
set statslev(rank) {
	""
	""
	""
	""
	""
	""
	""
	""
	""
	" "
	""
	""
	""
	""
	""
	""
	""
	""
	""
	""
	""
	""
	""
	""
	""
	""
	""
	""
	""
}
#     
set statslev(drank) {
	50
	100
	200
	300
	400
	500
	750
	1000
	1500
	2000
	3000
	4000
	5000
	6000
	7000
	8000
	9000
	10000
	15000
	20000
	25000
	30000
	40000
	50000
	60000
	70000
	80000
	90000
	100000
}
#  
set statslev(dmax) " !" 

#  
bind pub - ! ::statslev::pubrang
bind pub - !   ::statslev::pubrang
bind pub - !rang   ::statslev::pubrang
bind msg - ! ::statslev::msgrang
bind msg - !   ::statslev::msgrang
bind msg - !rang   ::statslev::msgrang

##
# don't edit anything below this line!
##

proc ::statslev::msgrang {nick uhost hand args} {
	subst -nob -noc -nov args
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	::statslev::pubrang $nick $uhost $hand $nick $args
}

proc ::statslev::pubrang { nick uhost hand chan text } {
	global statslev
	if {[string eq $nick $chan]} {
		if {[string first "#" [lindex $text 0]] == -1} {egglib::outh $nick $chan "!" "<#> <>"; return}
		set schan [lindex $text 0]
		set text [lindex $text 1]
	} else {
		if { [channel get $chan nopubstatslev] } { return }
		set schan $chan
	}
	if { [llength $text] > 1 } {
		egglib::outh $nick $chan "" "<>"
		return
	}
	if { $text == "" } {
		set vict [nick2suser $nick $schan]
	} else {
		set vict [nick2suser $text $schan]
		if { $vict == "" || $vict == "*" } {	
			set vict $text
		}
	}

	set userstat [getstats $vict $schan words]

	if {!$userstat} {
		egglib::out $nick $chan "    $vict."
		return
	}

	set honor ""
	set ko 0
	foreach item $statslev(drank) { 
		if {$userstat<=$item} { set honor [lindex $statslev(rank) $ko]; break}
		incr ko 
	} 
	if {$honor==""} {set honor $statslev(dmax)}
	incr ko
	egglib::out $nick $chan "$vict:  - $ko ($userstat [lindex {.   } [numgrp $userstat]]),  - $honor."
}
proc ::statslev::numgrp {number} { switch -glob -- "$number" { *11 {return 3} *12 {return 3} *13 {return 3} *14 {return 3} *1 {return 1} *2 {return 2} *3 {return 2} *4 {return 2} default {return 3} } }	
	
putlog "statslev.tcl $statslev(ver) by $statslev(author) loaded"